package banco;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.omg.CORBA.DoubleHolder;


class auto_atendimentoImpl extends auto_atendimentoPOA {
	private List<Conta> contas = new ArrayList<Conta>();
	
	public auto_atendimentoImpl() {
		contas.add(new Conta(234, 200));
		Conta a = new Conta(123, 200);
		a.novaTransação(2, "T. p/ 234", -100);
		contas.add(a);
	}
	
	public String boas_vindas() {
		return "Welcome to " + banco.nome_banco.value;
	};

	public double saldo(int c) throws banco.conta_inval {
		Conta conta = getConta(c);
		return conta.getSaldo();
	}

	public void extrato(int c, banco.transacoesHolder t,
			org.omg.CORBA.DoubleHolder saldo) throws banco.conta_inval {
		Conta conta = getConta(c);
		t.value = conta.getTransacoes();
		saldo.value = conta.getSaldo(); 
		System.out.println(saldo.value);
	}

	public Conta getConta(int c) throws conta_inval {
		for (int x = 0; x < contas.size(); x++) {
			Conta conta = contas.get(x);
			if (conta.getNumeroConta() == c) {
				return conta;
			}
		}
		throw new banco.conta_inval("Account inexistent", c);
	}

	public void transferencia(int origem, int destino, double v)
			throws banco.conta_inval, banco.saldo_insuf {
		Conta contaOrigem = null, contaDestino = null;

		contaOrigem = getConta(origem);
		contaDestino = getConta(destino);

		Date s = new Date();
		String data = "" + s.getYear() + s.getMonth() + s.getDay();

		if (contaOrigem.getSaldo() > v) {
			contaOrigem.novaTransação(new Integer(data),
					"T. p/ " + destino, -v);
			contaDestino.novaTransação(new Integer(data),
					"T. da " + origem, v);
		} else {
			throw new banco.saldo_insuf("Money insufficient", v);
		}
	}

	public void investimento(int c, banco.aplicacao apl, double v)
			throws banco.conta_inval, banco.saldo_insuf {
		Conta conta = getConta(c);
		if (conta.getSaldo() > v) { 
			conta.novaAplicação(apl);
		} else { 
			throw new banco.saldo_insuf("Money insufficient", v);
		}
	}
}